//-----------------------------------------------------------------
// @function      chkMaskCEP
// @desc          Aplica mscara de CEP automaticamente
// @param         field          campo de um formulrio
// @param         event          evento do teclado
// @returns       true | false
//-----------------------------------------------------------------
function chkMaskCEP(field,event) {
     var ns = ((document.layers || document.getElementById) && (!document.all));
     var ie = document.all;
     var keySet = '0123456789';
     var actionSet = '0,8,13';
     var keyCode = (ie) ? window.event.keyCode : event.which;
     var key = String.fromCharCode(keyCode);
     if ((keySet.indexOf(key) == -1) && (actionSet.indexOf(keyCode) == -1)) {
         return false;
     }
     else {
         if ((field.value.length == 9) && (actionSet.indexOf(keyCode) == -1)) {
             return false;
         }
         else if ((field.value.length == 9) && (actionSet.indexOf(keyCode) != -1)) {
             return true;
         }
         else if (field.value.length == 5) {
             field.value = field.value + '-';
             return true;
         }
         else {
             return true;
         }
     }
}

//-------------------------------------------------------------
// @function      chkCEP
// @desc          Verifica se o campo possui um CEP vlido
// @param         field        campo CEP a ser verificado
// @returns       true | false
//-------------------------------------------------------------
function chkCEP(field) {
     var objRegExp = /^\d{5}(\-)\d{3}$/
     if (field.value.length == 0) {
          return true;
     }
     if ((parseInt(field.value)) && (field.value.length == 8)) {
          field.value = field.value.substr(0,5) + '-' + field.value.substr(5,3);
     }
     if (!objRegExp.test(field.value)) {
          return false;
     }
     else {
          return true;
     }
}