//--------------------------------------------------------
// @function      chkMaskURL
// @desc          Aplica mscara de URL automaticamente
// @param         field          campo de um formulrio
// @param         event          evento do teclado
// @returns       true | false
//--------------------------------------------------------
function chkMaskURL(field,event) {
     var ns = ((document.layers || document.getElementById) && (!document.all));
     var ie = document.all;
     var keySet = "1234567890qwertyuiop[]asdfghjklzxcvbnm.:/@-_QWERTYUIOPASDFGHJKLZXCVBNM";
     var actionSet = '0,8,13';
     var keyCode = (ie) ? window.event.keyCode : event.which;
     var key = String.fromCharCode(keyCode);
     if ((keySet.indexOf(key) == -1) && (actionSet.indexOf(keyCode) == -1)) {
         return false;
     }
     else {
         return true;
     }
}

//-------------------------------------------------------------------
// @function      chkURL
// @desc          Verifica se uma URL est no formato correto
// @param         field        campo de data a ser verificada
// @returns       true | false
//-------------------------------------------------------------------
function chkURL(field) {
     if (field.value.length == 0) {
          return true;
     }
     var objRegExp = /^(((https?)|(ftp)):\/\/([\-\w]+\.)+\w{2,3}(\/[%\-\w]+(\.\w{2,})?)*(([\w\-\.\?\\/+@&#;`~=%!]*)(\.\w{2,})?)*\/?)/
     if (!objRegExp.test(field.value)) {
          return false;
     } else {
          return true;
     }
}