<?php
require_once("config/scribe.inc");
require_once(PHPSCRIBE_CLASS_HTML);
require_once(PHPSCRIBE_CLASS_FORMTEMPLATE);

$HTML = new Html();
$HTML->addStyle("phpscribe.css");
$HTML->addBodyCfg("bgColor='#d6d6d6'");
$HTML->makePage();
$HTML->header->setAndPrepare("header.tpl");
$HTML->header->replace(array("imagePath"=>PHPSCRIBE_IMAGE_PATH,
                             "localPath"=>PHPSCRIBE_ABSOLUTE_PATH,
                             "pageTitle"=>"Technical Specification"));
$HTML->footer->setAndPrepare("footer.tpl");
$HTML->footer->replace(array("imagePath"=>PHPSCRIBE_IMAGE_PATH,
                             "localPath"=>PHPSCRIBE_ABSOLUTE_PATH));
$HTML->printPage();

function Main() {
     $MAIN_TPL = new Template(PHPSCRIBE_TEMPLATE_PATH."main.tpl");
     $MAIN_TPL->prepare();
     $TECH_TPL = new Template(PHPSCRIBE_TEMPLATE_PATH."techspec.tpl");
     $TECH_TPL->prepare();
     $MAIN_TPL->assign("mainContent",$TECH_TPL->getOutputContent());
     $MAIN_TPL->assign("imagePath",PHPSCRIBE_IMAGE_PATH);
     $MAIN_TPL->printToScreen();
}
?>