<?php
require_once("config/scribe.inc");
require_once(PHPSCRIBE_CLASS_HTML);
require_once(PHPSCRIBE_CLASS_FORMTEMPLATE);

$HTML = new Html();
$HTML->addStyle("phpscribe.css");
$HTML->addBodyCfg("bgColor='#d6d6d6'");
$HTML->makePage();
$HTML->header->setAndPrepare("header.tpl");
$HTML->header->replace(array("imagePath"=>PHPSCRIBE_IMAGE_PATH,
                             "localPath"=>PHPSCRIBE_ABSOLUTE_PATH,
                             "pageTitle"=>"Changelog"));
$HTML->footer->setAndPrepare("footer.tpl");
$HTML->footer->replace(array("imagePath"=>PHPSCRIBE_IMAGE_PATH,
                             "localPath"=>PHPSCRIBE_ABSOLUTE_PATH));
$HTML->printPage();

function Main() {
     $MAIN_TPL = new Template(PHPSCRIBE_TEMPLATE_PATH."main.tpl");
     $MAIN_TPL->prepare();
     $CHL_TPL = new Template(PHPSCRIBE_TEMPLATE_PATH."changelog.tpl");
     $CHL_TPL->prepare();
     if (!$fp = @fopen("CHANGELOG.txt","r")) {
          $CHL_TPL->assign("changelog_content","Couldn't open the file CHANGELOG.txt. The file may be deleted.");
     } else {
          $CHL_TPL->assign("changelog_content",fread($fp,filesize("CHANGELOG.txt")));
     }
     $MAIN_TPL->assign("mainContent",$CHL_TPL->getOutputContent());
     $MAIN_TPL->assign("imagePath",PHPSCRIBE_IMAGE_PATH);
     $MAIN_TPL->printToScreen();
}
?>