<?php
//------------------------------------------------------------------
// test the user's database
//------------------------------------------------------------------
function testDatabase() {
     global $PS_USER_CFG;
     if ( (isset($PS_USER_CFG['DATABASE_HOST'])) && (isset($PS_USER_CFG['DATABASE_USER'])) && (isset($PS_USER_CFG['DATABASE_PASS'])) ) {
          if (!function_exists("mysql_connect")) {
               echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#FF0000'><B>FATAL ERROR!</B><BR><BR>Your server doesn't have mySQL support. phpScribe's not able to run without a functional mySQL database.</FONT><BR><BR><A HREF='http://www.mysql.com' STYLE='color:#ff0000;text-decoration:underline;font-weight:bold' TARGET='_blank'>Wanna download mySQL?</A></TD></TR>";
          } else if (!$link = @mysql_connect($PS_USER_CFG['DATABASE_HOST'],$PS_USER_CFG['DATABASE_USER'],$PS_USER_CFG['DATABASE_PASS'])) {
               echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#FF0000'>It wasn't possible to connect to yout mySQL database using the current settings!</FONT></TD></TR>";
          } else if (!@mysql_select_db($PS_USER_CFG['DATABASE_BASE'],$link)) {
               echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#FF0000'>It wasn't possible to select the provided database <B>".$PS_USER_CFG['DATABASE_BASE']."</B>!</FONT></TD></TR>";
          } else {
               if ((!isset($PS_USER_CFG)) || (!file_exists($PS_USER_CFG['GLOBAL_PATH']."/index.php"))) {
                    echo "<TR HEIGHT='60'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#FF0000'><B>The system couldn't find the phpScribe's main file index.php.<BR>Is the server path value right? (e.g.: \www\phpscribe)</B></FONT></TD></TR>";
               } else {
                    define("PHPSCRIBE_ADODB_PATH",$PS_USER_CFG['GLOBAL_PATH']."/adodb/");
                    require_once("classes/Db.class");
                    $DB = new Db();
                    $tables = $DB->conn->MetaTables();
                    $missingTables = array();
                    if (!in_array("class",$tables)) {
                         $missingTables[] = "class";
                    }
                    if (!in_array("example",$tables)) {
                         $missingTables[] = "example";
                    }
                    if (!in_array("file",$tables)) {
                         $missingTables[] = "file";
                    }
                    if (!in_array("file_type",$tables)) {
                         $missingTables[] = "file_type";
                    }
                    if (!in_array("function",$tables)) {
                         $missingTables[] = "function";
                    }
                    if (!in_array("param",$tables)) {
                         $missingTables[] = "param";
                    }
                    if (!in_array("project",$tables)) {
                         $missingTables[] = "project";
                    }
                    if (!in_array("property",$tables)) {
                         $missingTables[] = "property";
                    }
                    if (!in_array("revision",$tables)) {
                         $missingTables[] = "revision";
                    }
                    if (!in_array("see",$tables)) {
                         $missingTables[] = "see";
                    }
                    if (!in_array("uses",$tables)) {
                         $missingTables[] = "uses";
                    }
                    if (!empty($missingTables)) {
                         echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#ff0000'><B>The following phpScribe's system tables weren't found in your database: <B>".implode(",",$missingTables)."</B></FONT></TD>";
                    } else {
                         $RS = $DB->Query("SELECT * FROM file_type");
                         if ($DB->AffectedRows() == 0) {
                              echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#ff0000'><B>The table file_type must have at least one entry!</B></FONT></TD>";
                         } else {
                              echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#ff0000'><B>Your database is ok and ready to use!</B></FONT></TD>";
                         }
                    }
               }
          }
     } else {
          echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#ff0000'><B>The system couldn't find the database settings (host, user or password)...</B></FONT></TD>";
     }
}

//------------------------------------------------------------------
// save the user's settings
//------------------------------------------------------------------
function saveSettings() {
     $out = "<?\n";
     while(list($key,$value)=each($_POST)) {
          if (!ereg("btn",$key)) {
               $value = ($value == "1" ? "TRUE" : ($value == "0" ? "FALSE" : "\"".str_replace("\\\\","\\",$value)."\""));
               $out .= "\$PS_USER_CFG['".$key."']=".$value.";\n";
               $GLOBALS['PS_USER_CFG'][$key] = str_replace("\\\\","\\",$_POST[$key]);
          }
     }
     $out .= "\$PS_USER_CFG['CAPTURE_ERRORS']=TRUE;\n";
     $out .= "\$PS_USER_CFG['LOG_ERRORS']=TRUE;\n";
     $out .= "\$PS_USER_CFG['SHOW_ERRORS']=TRUE;\n";
     $out .= "?>\n";
     if (!$fp = @fopen("config/user.cfg","w")) {
          echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#ff0000'><B>Couldn't open settings file to write! ('config/user.cfg') Check file permissions!</B></FONT></TD></TR>";
     } else {
          fputs($fp,$out);
          fclose($fp);
          echo "<TR HEIGHT='40'><TD WIDTH='15'>&nbsp;</TD><TD COLSPAN='3' CLASS='bignormal'><FONT COLOR='#ff0000'><B>Settings successfully updated...</B></FONT></TD>";
     }
}

//------------------------------------------------------------------
// normal execution of the page
//------------------------------------------------------------------
@include_once("config/user.cfg");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<TITLE>:::: p h p S c r i b e ::::</TITLE><META NAME="TITLE" CONTENT=":::: p h p S c r i b e ::::">
<META NAME="AUTHOR" CONTENT="Marcos Pont">
<META NAME="DESCRIPTION" CONTENT="">
<META NAME="KEYWORDS" CONTENT="">
<META NAME="GENERATOR" CONTENT="PHP2Go Web Development Framework">
<META NAME="IDENTIFIER-URL" CONTENT="http://mpont.homedns.org/phpscribe">
<META NAME="DATE-CREATION-ddmmyyyy" CONTENT="11/06/2002">
<META NAME="CATEGORY" CONTENT="Outros">
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">
<LINK REL='stylesheet' type='text/css' HREF='resources/stylesheet/phpscribe.css'>
<SCRIPT LANGUAGE='JavaScript' SRC='resources/javascript/empty.js'></SCRIPT>
<SCRIPT>
function checkFormInstall()
{
     var msg = "";
     if (isEmpty("install","GLOBAL_PATH")) {
          msg = msg + "The field named GLOBAL_PATH is mandatory!\n";
     }
     if (isEmpty("install","ABSOLUTE_PATH")) {
          msg = msg + "The field named ABSOLUTE_PATH is mandatory!\n";
     }
     if (isEmpty("install","DATABASE_HOST")) {
          msg = msg + "The field named DATABASE_HOST is mandatory!\n";
     }
     if (isEmpty("install","DATABASE_USER")) {
          msg = msg + "The field named DATABASE_USER is mandatory!\n";
     }
     if (isEmpty("install","DATABASE_BASE")) {
          msg = msg + "The field named DATABASE_BASE is mandatory!\n";
     }
     if (msg != "") {
          alert(msg);
          return false;
     } else {
          document.install.submit();
     }
}
</SCRIPT>
</HEAD>
<BODY LEFTMARGIN='0' TOPMARGIN='0' MARGINWIDTH='0' MARGINHEIGHT='0' bgColor='#d6d6d6'>
<BR>
<TABLE WIDTH='604' ALIGN='center' CELLPADDING='0' CELLSPACING='0' BORDER='1' BORDERCOLOR='#006699'>
<TR BGCOLOR='#006699'><TD CLASS='whiteheading'>
&nbsp;phpScribe Installer
</TD></TR>
</TABLE>
<TABLE WIDTH='600' ALIGN='center' CELLPADDING='0' CELLSPACING='0' BORDER='1' BORDERCOLOR='#006699'>
<TR><TD ALIGN='center'>
<TABLE WIDTH='600' CELLPADDING='3' CELLSPACING='0' BORDER='0'>
<FORM NAME='install' ACTION='install.php' METHOD='post'>
<?
// salva alteraes se elas existem
if (!empty($_POST)) {
     saveSettings();
}
if ($_GET['test'] == "db") {
     testDatabase();
}
?>
<TR>
<TD WIDTH='15'>&nbsp;</TD>
<TD CLASS='bignormal'><BR>Step 1: phpScribe Settings</TD>
<TD ALIGN='right'><BR><A HREF='index.php' CLASS='normalblue'> Back to phpScribe's home</TD>
<TD WIDTH='15'>&nbsp;</TD>
</TR>
<TR>
<TD WIDTH='15'>&nbsp;</TD>
<TD COLSPAN='2'>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><SPAN CLASS='normal'>Type in the path of phpScribe in the web server:<BR>(e.g.: /home/httpd/html/, /var/www/html/)</SPAN><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><INPUT TYPE='text' NAME='GLOBAL_PATH' <?if (isset($PS_USER_CFG['GLOBAL_PATH'])) echo "VALUE='".$PS_USER_CFG['GLOBAL_PATH']."'";?> SIZE='60' MAXLENGTH='60'><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><SPAN CLASS='normal'>Type in the path of phpScribe to use as the url location:<BR>(e.g.: http://www.mydomain.com/myproject)</SPAN><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><INPUT TYPE='text' NAME='ABSOLUTE_PATH' SIZE='60' MAXLENGTH='60' <?if (isset($PS_USER_CFG['ABSOLUTE_PATH'])) echo "VALUE='".$PS_USER_CFG['ABSOLUTE_PATH']."'";?>><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><SPAN CLASS='normal'>Type your mySQL access information:</SPAN><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><SPAN CLASS='normal'>Host</SPAN><BR><INPUT TYPE='text' NAME='DATABASE_HOST' SIZE='60' MAXLENGTH='60' <?if (isset($PS_USER_CFG['DATABASE_HOST'])) echo "VALUE='".$PS_USER_CFG['DATABASE_HOST']."'";?>><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><SPAN CLASS='normal'>Username</SPAN><BR><INPUT TYPE='text' NAME='DATABASE_USER' SIZE='20' MAXLENGTH='20' <?if (isset($PS_USER_CFG['DATABASE_USER'])) echo "VALUE='".$PS_USER_CFG['DATABASE_USER']."'";?>><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><SPAN CLASS='normal'>Password</SPAN><BR><INPUT TYPE='password' NAME='DATABASE_PASS' SIZE='16' MAXLENGTH='16' <?if (isset($PS_USER_CFG['DATABASE_PASS'])) echo "VALUE='".$PS_USER_CFG['DATABASE_PASS']."'";?>><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><SPAN CLASS='normal'>Database</SPAN><BR><INPUT TYPE='text' NAME='DATABASE_BASE' SIZE='20' MAXLENGTH='20' <?if (isset($PS_USER_CFG['DATABASE_BASE'])) echo "VALUE='".$PS_USER_CFG['DATABASE_BASE']."'";?>><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><SPAN CLASS='normal'>DB Type (default mySQL)</SPAN><BR><INPUT TYPE='text' NAME='DATABASE_TYPE' SIZE='10' MAXLENGTH='10' <?if (isset($PS_USER_CFG['DATABASE_TYPE'])) echo "VALUE='".$PS_USER_CFG['DATABASE_TYPE']."'"; else echo "VALUE='mysql'"?> READONLY><BR><BR>
<IMG SRC='resources/image/spacer.gif' WIDTH='1' HEIGHT='25'><INPUT TYPE='button' NAME='btn_install' VALUE='Save Settings' onClick='checkFormInstall();'>
<?
?>
</TD>
<TD WIDTH='15'>&nbsp;</TD>
</FORM>
</TR>
<TR>
<TD WIDTH='15'>&nbsp;</TD>
<TD CLASS='bignormal'><BR>Step 2: Database Creation</TD>
<TD ALIGN='right'><BR><A HREF='index.php' CLASS='normalblue'> Back to phpScribe's home</TD>
<TD WIDTH='15'>&nbsp;</TD>
</TR>
<TR HEIGHT='50'><TD WIDTH='15'>&nbsp;</TD>
<TD COLSPAN='2'>
<A HREF='sql/phpscribe.zip' CLASS='normalblue'>Click here to download the SQL scripts to create phpScribe's system tables</A>
</TD>
<TD WIDTH='15'>&nbsp;</TD>
</TR>
<TR><TD WIDTH='15'>&nbsp;</TD>
<TD HEIGHT='40' VALIGN='top' COLSPAN='2'>
<A HREF='install.php?test=db' CLASS='normalblue'>Click here to verify if your phpScribe's database is ready to use</A>
</TD>
<TD WIDTH='15'>&nbsp;</TD>
</TR>
</TABLE>
</TD></TR>
</TABLE>
</BODY>
</HTML>