//---------------------------------------------------------
// @function      chkMaskEMAIL
// @desc          Aplica mscara de EMAIL automaticamente
// @param         field          campo de um formulrio
// @param         event          evento do teclado
// @returns       true | false
//---------------------------------------------------------
function chkMaskEMAIL(field,event) {
     var ns = ((document.layers || document.getElementById) && (!document.all));
     var ie = document.all;
     var keySet = "1234567890qwertyuiop[]asdfghjklzxcvbnm.@-_QWERTYUIOPASDFGHJKLZXCVBNM";
     var actionSet = '0,8,13';
     var keyCode = (ie) ? window.event.keyCode : event.which;
     var key = String.fromCharCode(keyCode);
     if ((keySet.indexOf(key) == -1) && (actionSet.indexOf(keyCode) == -1)) {
         return false;
     }
     else {
         return true;
     }
}

//----------------------------------------------------------------------
// @function      chkMAIL
// @desc          Verifica se um campo possui um valor de e-mail vlido
// @param         field          campo e-mail a ser verificado
// @returns       true | false
//----------------------------------------------------------------------
function chkEMAIL(field) {
     var keySet = "1234567890qwertyuiop[]asdfghjklzxcvbnm.@-_QWERTYUIOPASDFGHJKLZXCVBNM";
     for (var i=0; i<field.value.length; i++) {
          if (keySet.indexOf(field.value.charAt(i)) == -1) {
             return false;
          }
     }
     return (field.value.length == 0) || (field.value.search(/^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/) != -1);
}