//-----------------------------------------------------------------
// @function      chkMaskINTEGER
// @desc          Aplica mscara de nmero inteiro automaticamente
// @param         field          campo de um formulrio
// @param         event          evento do teclado
// @returns       true | false
//-----------------------------------------------------------------
function chkMaskINTEGER(field,event) {
     var ns = ((document.layers || document.getElementById) && (!document.all));
     var ie = document.all;
     var keySet = '0123456789';
     var actionSet = '0,8,13';
     var keyCode = (ie) ? window.event.keyCode : event.which;
     var key = String.fromCharCode(keyCode);
     if ((keySet.indexOf(key) == -1) && (actionSet.indexOf(keyCode) == -1)) {
         return false;
     }
     else {
         return true;
     }
}

//-------------------------------------------------------------
// @function      chkINTEGER
// @desc          Verifica se o campo possui um nmero inteiro
// @param         field        campo inteiro a ser verificado
// @returns       true | false
//-------------------------------------------------------------
function chkINTEGER(field) {
     if (field.value.length == 0) {
         return true;
     }
     else if (parseInt(field.value)) {
         return true;
     }
     else {
         return false;
     }
}