//-----------------------------------------------------------------
// @function      chkMaskMOEDA
// @desc          Aplica mscara de MOEDA automaticamente
// @param         field          campo de um formulrio
// @param         event          evento do teclado
// @returns       true | false
//-----------------------------------------------------------------
function chkMaskMOEDA(field,event) {
     var ns = ((document.layers || document.getElementById) && (!document.all));
     var ie = document.all;
     var keySet = '0123456789';
     var actionSet = '0,8,13';
     var keyCode = (ie) ? window.event.keyCode : event.which;
     var key = String.fromCharCode(keyCode);
     var fieldValue = field.value;
     var newValue = "";
     if ((keySet.indexOf(key) == -1) && (actionSet.indexOf(keyCode) == -1)) {
         return false;
     }
     else if (actionSet.indexOf(keyCode) != -1) {
         return true;
     }
     else if (field.value.length == field.maxLength) {
         return false;
     }
     else {
         fieldValue = field.value.replace(",","");
         while (fieldValue.indexOf('.') != -1) fieldValue = fieldValue.replace(".","");
         var inicio   = fieldValue.substr(0,((fieldValue.length-1)%3));
         var centavos = fieldValue.substr(fieldValue.length-1,1);
         var resto    = fieldValue.substr(((fieldValue.length-1)%3),fieldValue.length-1-((fieldValue.length-1)%3));
         if (inicio != "") {
             newValue = newValue + inicio;
         }
         for (i=0; i<resto.length; i++) {
             if (((i>0) && ((i%3)==0)) || ((i==0) && (inicio != ""))) {
                newValue = newValue + '.';
             }
             newValue = newValue + resto.charAt(i);
         }
         if (fieldValue.length >= 2) {
             newValue = newValue + ',';
         }
         newValue = newValue + centavos;
         field.value = newValue;
     }
}

//-----------------------------------------------------------------
// @function chkMOEDA
// @desc     Verifica se o campo possui um valor vlido de moeda
// @param    fied     campo moeda a ser verificado
// @returns  true | false
//-----------------------------------------------------------------
function chkMOEDA(field) {
     var strRegExp = "";
     var size = field.value.length;
     var inicio = (size - 3)%4;
     var resto = size - inicio - 3;
     if (size == 0) {
         return true;
     } else {
         strRegExp = "/^\\d{"+inicio+"}";
         for (var i=0; i<resto; i=i+4) {
              strRegExp = strRegExp + "(\\.)\\d{3}";
         }
         strRegExp = strRegExp + "(\\,)\\d{2}$/";
         eval("var objRegExp = "+strRegExp);
         if (objRegExp.test(field.value)) {
             return true;
         }
         else {
             return false;
         }
     }
}